function main()
%{
  Sample script to calculate monthly mean Bext (from visibility) from NCDC
  DS3500 global hourly surface database, available here:
http://cdo.ncdc.noaa.gov/pls/plclimprod/cdomain.abbrev2id

This uses the file downloaded from the the web interface, not sure if the
files on the ftp site have the same format.

Make sure to use 'Advanced Options' and 'All variables' to match up the
file formats.

%}

    clear all;

	figFormat = 'pdf';

    dataDir = '/home/rfield1/storage/observations/NCDCGSOD/'; 
	ftpSite = 'ftp.ncdc.noaa.gov'; % ftp://ftp.ncdc.noaa.gov/pub/data/gsod/2015/
	ftpRootDir = 'pub/data/gsod/';

	ftpTheData = 1;
	nDaysGetWXU = 2;
    
	visScale = [ 0 15];

	currStn = 0;	

	currStn = currStn + 1;
	stnNames(currStn) = cellstr('Palangkaraya - Tjilik Riwut');
	stnIDs(currStn) = cellstr('966550-99999'); 
	lats(currStn) = -2.225;
	lons(currStn) = 113.943;

    currStn = currStn + 1;
	stnNames(currStn) = cellstr('Muara Teweh');
	stnIDs(currStn) = cellstr('965950-99999'); 
	lats(currStn) = -0.95;
	lons(currStn) = 114.9;

%{
	currStn = currStn + 1;
    stnNames(currStn) = cellstr('Beijing IA');
	stnIDs(currStn) = cellstr('545110-99999');
	lats(currStn) = 40.08;
	lons(currStn) = 116.585;
%}

	currStn = currStn + 1;
    stnNames(currStn) = cellstr('Singapore-Changi');
	stnIDs(currStn) = cellstr('486980-99999');
	lats(currStn) = 1.35;
	lons(currStn) = 103.994;

    
	currStn = currStn + 1;
    stnNames(currStn) = cellstr('Mopah');
	stnIDs(currStn) = cellstr('979800-99999');
	lats(currStn) = -8.52;
	lons(currStn) = 140.418;

	currStn = currStn + 1;
    stnNames(currStn) = cellstr('Tanah Merah');
	stnIDs(currStn) = cellstr('978760-99999');
	lats(currStn) = -6.1;
	lons(currStn) = 140.3;



%{
% Don't think wx underground update works for stations with Airport codes, fields are all mixed up
	currStn = currStn + 1;
    stnNames(currStn) = cellstr('Phnom Penh');
	stnIDs(currStn) = cellstr('489910-99999');

	currStn = currStn + 1;
    stnNames(currStn) = cellstr('Phuket IA');
	stnIDs(currStn) = cellstr('485650-99999');
	lats(currStn) = 8.113;
	lons(currStn) = 93.317;

%}


	currStn = currStn + 1;
    stnNames(currStn) = cellstr('Palembang-Sultan Mahumd Badaruddin');
	stnIDs(currStn) = cellstr('962210-99999');
	lats(currStn) = -2.898;
	lons(currStn) = 104.71;

	currStn = currStn + 1;
    stnNames(currStn) = cellstr('Jambi-Sultan Thaha');
	stnIDs(currStn) = cellstr('961950-99999');
	lats(currStn) = -1.638;
	lons(currStn) = 103.644;
    
	currStn = currStn + 1;
    stnNames(currStn) = cellstr('Pangkalpinang');
	stnIDs(currStn) = cellstr('962370-99999');
	lats(currStn) = -2.17;
	lons(currStn) = 106.13;

	currStn = currStn + 1;
    stnNames(currStn) = cellstr('Dabo');
	stnIDs(currStn) = cellstr('961790-99999');
	lats(currStn) = -0.479;
	lons(currStn) = 104.579;

	currStn = currStn + 1;
    stnNames(currStn) = cellstr('Tanjung Pandan-H AS Hanandjoeddin');
	stnIDs(currStn) = cellstr('962490-99999');
	lats(currStn) = -2.746;
	lons(currStn) = 107.755;


	currStn = currStn + 1;
    stnNames(currStn) = cellstr('Japura');
	stnIDs(currStn) = cellstr('961710-99999');
	lats(currStn) = -0.353;
	lons(currStn) = 102.335;

	currStn = currStn + 1;
    stnNames(currStn) = cellstr('Pakanbaru-Sultan Syarif Kasim II');
	stnIDs(currStn) = cellstr('961090-99999');
	lats(currStn) = 0.461;
	lons(currStn) = 101.445;

	currStn = currStn + 1;
    stnNames(currStn) = cellstr('Medan');
	stnIDs(currStn) = cellstr('960330-99999');
	lats(currStn) = 3.8;
	lons(currStn) = 98.7;


	currStn = currStn + 1;
    stnNames(currStn) = cellstr('Banda Aceh-Sultan Iskandarmuda');
	stnIDs(currStn) = cellstr('960110-99999');
	lats(currStn) = 5.524;
	lons(currStn) = 95.42;

	currStn = currStn + 1;
	stnNames(currStn) = cellstr('Pontianak-Supadio');
	stnIDs(currStn) = cellstr('965810-99999'); 
	lats(currStn) = -0.151;
	lons(currStn) = 109.404;

	currStn = currStn + 1;
	stnNames(currStn) = cellstr('Ketapang-Rahadi Usman');
	stnIDs(currStn) = cellstr('966150-99999'); 
	lats(currStn) = -1.817;
	lons(currStn) = 109.963;

	currStn = currStn + 1;
	stnNames(currStn) = cellstr('Sintang-Susilo');
	stnIDs(currStn) = cellstr('965590-99999'); 
	lats(currStn) = 0.064;
	lons(currStn) = 111.473;

	currStn = currStn + 1;
	stnNames(currStn) = cellstr('Nanganpinoh');
	stnIDs(currStn) = cellstr('965570-99999'); 
	lats(currStn) = -0.35;
	lons(currStn) = 111.783;

	currStn = currStn + 1;
	stnNames(currStn) = cellstr('Pangkalanbun-Iskandar');
	stnIDs(currStn) = cellstr('966450-99999'); 
	lats(currStn) = -2.705;
	lons(currStn) = 111.673;

	currStn = currStn + 1;
	stnNames(currStn) = cellstr('Banjarmasin-Syamsudin Noor');
	stnIDs(currStn) = cellstr('966850-99999'); 
	lats(currStn) = -3.442;
	lons(currStn) = 114.763;

	currStn = currStn + 1;
	stnNames(currStn) = cellstr('Samarinda-Temindung');
	stnIDs(currStn) = cellstr('966070-99999'); 
	lats(currStn) = -0.485;
	lons(currStn) = 117.157;


	currStn = currStn + 1;
	stnNames(currStn) = cellstr('Balikpapan-Sepinggan');
	stnIDs(currStn) = cellstr('966330-99999'); 
	lats(currStn) = -1.268;
	lons(currStn) = 116.894;

	currStn = currStn + 1;
	stnNames(currStn) = cellstr('Tanjung Selor');
	stnIDs(currStn) = cellstr('965250-99999'); 
	lats(currStn) = 2.85;
	lons(currStn) = 117.333;

	currStn = currStn + 1;
    stnNames(currStn) = cellstr('Kuala Lumpur-Aziz'); % NEED CHECK
	stnIDs(currStn) = cellstr('486470-99999');
	lats(currStn) = 3.131;
	lons(currStn) = 101.549;


	currStn = currStn + 1;
    stnNames(currStn) = cellstr('Kuching');
	stnIDs(currStn) = cellstr('964130-99999');
	lats(currStn) = 1.485;
	lons(currStn) = 110.347;
    
%{
Don't currently work w/ wx underground prob because of secondary ID
	currStn = currStn + 1;
    stnNames(currStn) = cellstr('Fresno');
	stnIDs(currStn) = cellstr('723890-93193');

	currStn = currStn + 1;
    stnNames(currStn) = cellstr('Denver');
	stnIDs(currStn) = cellstr('725650-03017');
%}



	nStn = currStn;
  
    RHThresh = 95; % relative humidity threshold above which observations are excluded
    zeroVisReplacement = .1; % in meters. replace any 0-visib with this in calculating Bext
	highVisReplacement = 10
    KoschmeiderFactor = 1.9; % from Schichtel et al. 2001, Atm. Env.-haze trends over US....km or il

	yearPlotStart = 1994;
	yearPlotEnd = 2015;

	startDateNum = datenum(yearPlotStart,1,1);
	endDateNum = datenum(yearPlotEnd,12,31);
	nDays = endDateNum-startDateNum + 1;

	yearList = [1997,2006,2015]; %[1994, 1997,2002,2004,2005,2006,2009,2012,2013,2014,2015];
	nListYear = size(yearList,2);
	smoothDays = 7;

    
	if (ftpTheData)
		gsodFTP = ftp(ftpSite,'anonymous','robert.field@columbia.edu');
	end
	for currStn = 1:nStn
		stnID = char(stnIDs(currStn));
		stnName = char(stnNames(currStn));
		currDir = [dataDir stnID '/']; mkdir(currDir); cd(currDir);

		% download file
		% extract required fields
		dateStr = [];
		tempStr = [];
		dewpStr = [];
		visibStr = [];
		windSpdStr = [];
		maxWindSpdStr = [];
		maxTempStr = [];
		prcpStr = [];
		for currYear = yearPlotStart:yearPlotEnd
			currFTPDir = [ftpRootDir num2str(currYear) '/'];
			currFileName = [currFTPDir stnID '-' num2str(currYear) '.op']; % 961090-99999-2015.op.gz;

			if (ftpTheData)			
		        doesFileExist = dir(gsodFTP,[currFTPDir stnID '*']);

				% only re-get data for the current year, other data won't be changing
		        if (~isempty(doesFileExist))
			    	system(['rm ' currFileName]);
					system(['rm ' currFileName '.gz']);
		            mget(gsodFTP,[currFileName '.gz']);
				end
			end

			if (exist( [dataDir stnID '/'  currFileName '.gz']))

                system(['gunzip ' currFileName '.gz']);

                fid = fopen([currDir currFileName]);
                currData = textscan(fid, '%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s', 'delimiter', ' ','MultipleDelimsAsOne', 1,'HeaderLines',1);
                fclose(fid);


                % extract required fields
                dateStr = [dateStr currData{3}'];
                tempStr = [tempStr currData{4}'];
                dewpStr = [dewpStr currData{6}'];
                visibStr = [visibStr currData{12}'];
                windSpdStr = [windSpdStr currData{14}'];
                maxWindSpdStr = [maxWindSpdStr currData{16}'];
                maxTempStr = [maxTempStr currData{18}'];
                prcpStr = [prcpStr currData{20}'];
            end

			% ncdc data is 1-2 days behind. Could try weather underground to fill gap
			% http://www.wunderground.com/history/wmo/96655/2015/9/15/CustomHistory.html?dayend=15&monthend=9&yearend=2015&req_city=&req_state=&req_statename=&reqdb.zip=&reqdb.magic=&reqdb.wmo=&format=1
			% weather underground doesn't have as much historical data (eg. 1997), so can't generally be used

		end

		lastDateStr = dateStr(end);
		lastDateNum = datenum(lastDateStr,'yyyymmdd');
		wxuDelim = '<br />';
        
        wxuTempCol = 3;
        wxuDewpCol = 6;
        wxuVisibCol = 15;
        wxuWindSpdCol = 18;
        wxuMaxWindSpdStrCol =17 ;
        wxuMaxTempStrCol = 2;
        wxuPrcpStrCol =20 ;
		for currExtraDay = 1:nDaysGetWXU
			currDateNum = lastDateNum + currExtraDay;

			currDateVec = datevec(currDateNum);
            currDateStr = datestr(currDateNum,'yyyymmdd');
            currYear = currDateVec(1)
            currMonth = currDateVec(2);
            currDay = currDateVec(3);
            
			currURL = ['http://www.wunderground.com/history/wmo/' ...
					   char(stnID(1:5)) '/' num2str(currYear) '/' num2str(currMonth) '/' num2str(currDay) '/' ...
					   'CustomHistory.html?dayend=' num2str(currDay) ...
                       '&monthend=' num2str(currMonth) ...
                       '&yearend=' num2str(currYear) ...
                       '&req_city=&req_state=&req_statename=&reqdb.zip=&reqdb.magic=&reqdb.wmo=&format=1'];

			currURLStr = urlread(currURL);
			lineBreakI = regexp(currURLStr,wxuDelim);
			currDataStart  = lineBreakI(1) + length(wxuDelim);
            currURLStr = currURLStr(currDataStart:end);
            
            currData = textscan(currURLStr,'%s','delimiter',',');
            dateStr = [dateStr cellstr(currDateStr)'];
            tempStr = [tempStr cellstr(currData{1}{wxuTempCol})'];
            dewpStr = [dewpStr cellstr(currData{1}{wxuDewpCol})'];
            visibStr = [visibStr cellstr(currData{1}{wxuVisibCol})'];
            windSpdStr = [windSpdStr cellstr(currData{1}{wxuWindSpdCol})'];
            maxWindSpdStr = [maxWindSpdStr cellstr(currData{1}{wxuMaxWindSpdStrCol})'];
            maxTempStr = [maxTempStr cellstr(currData{1}{wxuMaxTempStrCol})'];
            prcpStr = [prcpStr cellstr([currData{1}{wxuPrcpStrCol} 'X'])'];

		end

		% These are the positions in a line of the variables of interest. 
		% They come from manual inspection of the first few lines.
		% For any additional parameters, need ramp up to something more sophisticated.
		% 1     2      3           4    5     6    7    8     9    10    11  12    13   14   15  16      17      18      19    20     21     22 
		%STN---,WBAN , YEARMODA,   TEMP,  ,   DEWP,  ,  SLP  ,  ,  STP  ,  , VISIB,  ,  WDSP,  , MXSPD,  GUST,   MAX  ,  MIN  ,PRCP  ,SNDP , FRSHTT,
		%483270,99999, 19730101,   68.9,22,   61.9,22, 1013.8, 7, 9999.9, 0,   5.6,22,   0.4,21,   4.9, 999.9,   84.2 ,  55.4 , 1.22A,999.9, 100000,

		% space delimited format for ftp
		%STN--- WBAN   YEARMODA    TEMP       DEWP      SLP        STP       VISIB      WDSP     MXSPD   GUST    MAX     MIN   PRCP   SNDP   FRSHTT
		%961090 99999  20150101    77.6 20    73.1 20  9999.9  0  9999.9  0    4.7 20    1.2 20    8.0  999.9    83.8    73.4*  0.00I 999.9  000000





		nObs = size(dateStr,2);
		% do text and unit conversions

		dataArray = NaN*ones(nDays,10);
		datevecArray = [];

		% This loop reads in each line of file, storing the date,visibility
		% temperature and dew point.
		tic
		for obsCount = 1:nObs
		    
		    % Output the progress occaisionally
		    if (mod(obsCount,1000) == 0)
		        disp([ num2str(obsCount) ' lines processed']);
		    end
		    
		    % Retrieve date and time info
		    currDateNum = datenum(dateStr(obsCount),'yyyymmdd');
		    currDateVec = datevec(currDateNum);
		    
		    % Retrieve visibility and compute Bext
		    currVis = str2num(char(visibStr(obsCount)));
		    if (~(currVis == 999.9))
		        if (currVis == 0)
		            currVis = zeroVisReplacement;
		        end
		        currVis = 1.61*currVis;
		        currBext = KoschmeiderFactor/currVis;
		    else
		        currBext = NaN;
		        currVis = NaN;
		    end
		    
		    % Retrieve temperature and dew point, compute RH
		    currTemp = str2num(char(tempStr(obsCount))); % Tc = (5/9)*(Tf-32)
		    if (~(currTemp == 99.99))
				currTemp = (5/9)*(currTemp-32);
			else
				currTemp = NaN;
			end
		
			currDewp = str2num(char(dewpStr(obsCount)));
		    if (~(currDewp == 99.99))
				currDewp = (5/9)*(currDewp-32);
			else
				currDewp = NaN;
			end
		
		    if (~(isempty(currTemp) | isempty(currDewp)))
		        currRH = RHCalc(currTemp, currDewp);
                if (currRH > RHThresh)
                    currVis = NaN;
                    currBext = NaN;
                end
            else
                currVis = NaN;
                currBext = NaN;
		        currRH = NaN;
		    end

			% wind
		    currWdSpd = str2num(char(windSpdStr(obsCount))); %1.609344
		    if (~(currWdSpd == 999.9))
				currWdSpd = 1.609344*(currWdSpd);
			else
				currWdSpd = NaN;
			end
		
		    currMaxWdSpd = str2num(char(maxWindSpdStr(obsCount)));
		    if (~(currMaxWdSpd == 999.9))
				currMaxWdSpd = 1.609344*(currMaxWdSpd);
			else
				currMaxWdSpd = NaN;
			end
				
			% precip 
			currPrcpStr = char(prcpStr(obsCount));
			if (strfind(currPrcpStr,'99.99'))
				currPrcp = 0.0; % a big assumption
			else
				currPrcp = str2num(currPrcpStr(1:end-1));
				currPrcp = 25.4*currPrcp;
			end
		
		    % Save values for current line
			currEntry = currDateNum-startDateNum + 1;
			datevecArray(currEntry) = currDateNum;
		    dataArray(currEntry,1)= currDateVec(1); % year
		    dataArray(currEntry,2)= currDateVec(2); % month
		    dataArray(currEntry,3)= currDateVec(3); % day
		    
		    dataArray(currEntry,4) = currTemp;
		    dataArray(currEntry,5) = currRH;
		    dataArray(currEntry,6) = currWdSpd;
		    dataArray(currEntry,7) = currMaxWdSpd;
		    dataArray(currEntry,8) = currPrcp;
		    dataArray(currEntry,9) = currBext;
		    dataArray(currEntry,10) = currVis;
		    
		end
		toc
		
		

		% Now perform linear interpolation over each field to fill in missing days. 
		% This isn't great for precip, so pay attention to how many missing days there are
		dateRange = [startDateNum:endDateNum];
		currDateVec = datevec(dateRange);
		dataArray(:,1) = currDateVec(:,1);
		dataArray(:,2) = currDateVec(:,2);
		dataArray(:,3) = currDateVec(:,3);


		% make a plot of annual visibility.
		% smooth>

		close all;
		figH =  figure('visible','off'); hold on;

		currCM = hsv(nListYear); %jet(yearPlotEnd-yearPlotStart+1);
		currCM(nListYear,:) = [0 0 0]; %currCM(yearPlotEnd-yearPlotStart+1,:) = [ 0 0 0 ];

        clear yearStrs;
		currGoodYears = 0;
		for currYearI = 1:nListYear
			currYear = yearList(currYearI);
			currDataI = find(dataArray(:,1) == currYear);
			currData = dataArray(currDataI,10);
			currDates = datenum(dataArray(currDataI,1:3));
			currNObs = size(currData,1);
		    
		    clear smoothData; clear fakeDateNum; clear unSmoothData;

			if (currNObs > smoothDays)
				currGoodYears = currGoodYears + 1;
				for currOb = 1:currNObs
					currDateNum = currDates(currOb);
					currDateVec = datevec(currDateNum);
					if (currDateNum <=max(datevecArray))
					    unSmoothData(currOb) = nanmean(currData(currOb));%),'includenan');
					    smoothData(currOb) = nanmean(currData(currOb-min(currOb,smoothDays)+1:currOb));%),'includenan');
						fakeDateNum(currOb) = datenum(yearList(1),currDateVec(2),currDateVec(3)); 
					end
				end

		
				currLineWidth = 2;
				plot(fakeDateNum,smoothData,'Color',currCM(currYearI,:),'LineWidth',currLineWidth);
				if (currYearI == nListYear)
				   currLineWidth = 4; 
					plot(fakeDateNum,smoothData,'Color',currCM(currYearI,:),'LineWidth',currLineWidth);
					
					% thin grey unsmoothed line for last year
					plot(fakeDateNum,unSmoothData,'Color',[0.5 .5 .5],'LineWidth',1);

					scatter(fakeDateNum(end),unSmoothData(end),'MarkerFaceColor',[0.5 .5 .5],'MarkerEdgeColor',[0.5 .5 .5],'LineWidth',3);
				end

				datetick('x','mmm');
				yearStrs(currGoodYears) = cellstr(num2str(currYear));
				ylabel('Visibility (km)')
			end
		end
		title({[stnName ', ' stnID(1:6) ', (' num2str(lats(currStn)) ',' num2str(lons(currStn)) ')']; ...
              ['NOAA NCDC GSOD visibility, ' num2str(smoothDays) '-day back-average'];...
              ['Records with RH > ' num2str(RHThresh) '% excluded'];...
			  ['Data ending ' datestr(max(datevecArray),'yyyymmdd') ]});
		
		legend(yearStrs,'box','off','Location','EastOutSide');
		ylim(visScale);
		figPos = get(figH,'OuterPosition');
		set(figH,'OuterPosition',[figPos(1) figPos(2) 3*figPos(3) 2*figPos(4)]);


        fileName = [dataDir stnID '.' stnName '.' num2str(yearList(1)) '.' num2str(yearList(end))];
		print([fileName '.' figFormat],['-d' figFormat]);




		outputFileName = [ fileName '.converted.csv'];
		fid = fopen(outputFileName,'w');
		headerString = 'YYYY,MM,DD,Tmean,RH,WdSpd,WdSpdMax,Prcp,Bext,Vis';
		fprintf(fid,'%s\n',headerString);
		fclose(fid);
		dlmwrite([outputFileName],dataArray,'-append');
	end
	if (ftpTheData)
		close(gsodFTP);
	end
end

function RH = RHCalc(temp, dewp)

    % can't remember where this is from...
    RH = 100*exp(-5423*(temp- dewp)/((temp+ 273.16)^2));

end
